package astern


object LexicographicListComparator : Comparator<List<Any?>> {

    private val elementComparator: Comparator<String> = Comparator { o1, o2 ->
        o1.compareTo(
            o2
        )
    }

    override fun compare(o1: List<Any?>?, o2: List<Any?>?): Int {
        val i1 = o1!!.iterator()
        val i2 = o2!!.iterator()
        while (i1.hasNext() && i2.hasNext()) {
            val cmp = elementComparator.compare(i1.next() as String, i2.next() as String)
            if (cmp != 0) return cmp
        }
        if (i1.hasNext() && !i2.hasNext()) return 1
        return if (!i1.hasNext() && i2.hasNext()) -1 else 0
    }


}